import { jsxs as j, jsx as p, Fragment as xe } from "react/jsx-runtime";
import P, { useRef as f, useState as A, useLayoutEffect as L, useMemo as z, useEffect as C, useId as Z, useReducer as ee, useCallback as re } from "react";
import c from "clsx";
/*!
  @versini/ui-form v1.6.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_FORM__ || (window.__VERSINI_UI_FORM__ = {
    version: "1.6.0",
    buildTime: "09/18/2024 11:58 AM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
/*!
  @versini/ui-textarea v1.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_TEXTAREA__ || (window.__VERSINI_UI_TEXTAREA__ = {
    version: "1.0.0",
    buildTime: "09/18/2024 11:58 AM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const te = "av-text-area", ke = "av-text-area-wrapper", X = "av-text-area-helper-text", ve = "av-text-area__control--right";
function Te() {
  const e = f(!1);
  return C(() => (e.current = !0, () => {
    e.current = !1;
  }), []), re(() => e.current, []);
}
function we(e) {
  return z(() => e.every((t) => t == null) ? () => {
  } : (t) => {
    e.forEach((r) => {
      typeof r == "function" ? r(t) : r != null && (r.current = t);
    });
  }, e);
}
const _e = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};
function Ae(e) {
  const t = Te(), r = f(0), n = f(null), [o, l] = A(_e), a = z(() => typeof ResizeObserver > "u" ? null : new ResizeObserver((i) => {
    const s = i[0];
    s && (cancelAnimationFrame(r.current), r.current = requestAnimationFrame(() => {
      n.current && t() && l(s.contentRect);
    }));
  }), [t]);
  return C(() => (n.current && (a == null || a.observe(n.current, e)), () => {
    a == null || a.disconnect(), r.current && cancelAnimationFrame(r.current);
  }), [a, e]), [n, o];
}
function Ne({
  value: e,
  defaultValue: t,
  finalValue: r,
  onChange: n = () => {
  },
  initialControlledDelay: o = 0
}) {
  const [l, a] = A(!1), [i, s] = A(
    t !== void 0 ? t : r
  ), d = (m) => {
    s(m), n == null || n(m);
  };
  return C(() => {
    (async () => e !== void 0 && !l && o > 0 && (await new Promise(
      (m) => setTimeout(m, o)
    ), a(!0)))();
  }, [e, o, l]), e !== void 0 ? !l && o > 0 ? ["", n, !0] : [e, n, !0] : [i, d, !1];
}
function Ee(e) {
  const t = Z();
  if (!e)
    return t;
  if (typeof e == "number" || typeof e == "string")
    return `${e}${t}`;
  if (typeof e == "object") {
    const { id: r, prefix: n = "" } = e;
    return typeof r == "number" || typeof r == "string" ? `${n}${r}` : `${n}${t}`;
  }
}
const ne = "SET_ANNOUNCEMENT", oe = "CLEAR_ANNOUNCEMENT", Ie = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, Re = (e, t) => {
  switch (t == null ? void 0 : t.type) {
    case ne:
      return {
        ...e,
        announcement: t.payload
      };
    case oe:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, $e = ({
  onAnnouncementClear: e,
  dispatch: t
}) => {
  t({
    type: oe
  }), typeof e == "function" && e();
}, W = ({
  children: e,
  clearAnnouncementDelay: t,
  clearAnnouncementTimeoutRef: r,
  onAnnouncementClear: n,
  dispatch: o
}) => {
  (r == null ? void 0 : r.current) !== null && clearTimeout(r.current), e !== null && o({
    type: ne,
    payload: e
  }), t && (r.current = setTimeout(
    () => $e({
      onAnnouncementClear: n,
      dispatch: o
    }),
    t
  ));
}, Ce = ({
  children: e,
  announcementTimeoutRef: t,
  announcementDelay: r,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: o,
  onAnnouncementClear: l,
  dispatch: a
}) => {
  clearTimeout(t.current), r ? t.current = setTimeout(W, r, {
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: o,
    onAnnouncementClear: l,
    dispatch: a
  }) : W({
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: o,
    onAnnouncementClear: l,
    dispatch: a
  });
};
function Me({
  children: e,
  className: t,
  politeness: r,
  role: n = null,
  announcementDelay: o,
  clearAnnouncementDelay: l,
  onAnnouncementClear: a,
  visible: i,
  ...s
}) {
  const d = f(), m = f(), [b, g] = ee(Re, {
    announcement: null
  });
  let h = r;
  typeof h > "u" && (h = n ? Ie[n] : "assertive"), C(() => {
    Ce({
      announcementTimeoutRef: d,
      announcementDelay: o,
      children: e,
      clearAnnouncementDelay: l,
      clearAnnouncementTimeoutRef: m,
      onAnnouncementClear: a,
      dispatch: g
    });
  }, [
    e,
    o,
    l,
    a
  ]);
  const u = c(t, {
    "sr-only": !i
  });
  return /* @__PURE__ */ p(
    "div",
    {
      "aria-live": h,
      ...n && { role: n },
      className: u,
      ...s,
      children: b.announcement
    }
  );
}
const De = (e) => {
  let t = "";
  if (typeof e == "number" || typeof e == "string")
    t = "m-" + e;
  else {
    const r = [];
    (e == null ? void 0 : e.t) !== void 0 && r.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && r.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && r.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && r.push(`ml-${e.l}`), t = r.join(" ");
  }
  return t;
};
/*!
  @versini/ui-private v1.4.10
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PRIVATE__ || (window.__VERSINI_UI_PRIVATE__ = {
    version: "1.4.10",
    buildTime: "09/18/2024 11:57 AM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Oe = () => "rounded-md text-base h-20 min-h-[80px] resize-none overflow-hidden px-4 py-7", Be = ({
  mode: e
}) => c({
  "bg-surface-darker text-copy-lighter caret-copy-light": e === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": e === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": e === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": e === "alt-system"
}), Ve = ({
  focusMode: e
}) => c("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), He = ({
  noBorder: e,
  error: t
}) => c("border-2", {
  "border-border-dark": !e && !t,
  "focus:border-border-dark": !e && t,
  "border-border-error-dark": !e && t,
  "border-transparent": e
}), Ue = ({
  disabled: e,
  raw: t,
  error: r,
  mode: n
}) => {
  if (t)
    return "";
  if (e)
    return c("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!r)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": n === "dark",
      "text-copy-dark": n === "light",
      "text-copy-dark dark:text-copy-medium": n === "system",
      "text-copy-medium dark:text-copy-dark": n === "alt-system"
    });
  if (r)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": n === "dark",
      "text-copy-error-dark": n === "light",
      "text-copy-error-dark dark:text-copy-error-light": n === "system",
      "text-copy-medium dark:text-copy-error-dark": n === "alt-system"
    });
}, Fe = ({
  error: e,
  raw: t,
  mode: r,
  disabled: n
}) => {
  if (t)
    return "";
  if (n)
    return c(
      X,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!e)
    return c(X, "absolute px-2 font-medium", {
      "text-copy-medium": r === "dark",
      "text-copy-dark": r === "light",
      "text-copy-dark dark:text-copy-medium": r === "system",
      "text-copy-medium dark:text-copy-dark": r === "alt-system"
    });
  if (e)
    return c(X, "absolute px-2 font-medium", {
      "text-copy-error-light": r === "dark",
      "text-copy-error-dark": r === "light",
      "text-copy-error-dark dark:text-copy-error-light": r === "system",
      "dark:text-copy-error-dark text-copy-error-light": r === "alt-system"
    });
}, Le = ({
  className: e,
  textAreaClassName: t,
  raw: r,
  focusMode: n,
  disabled: o,
  noBorder: l,
  error: a,
  spacing: i,
  mode: s
}) => {
  const d = r ? e : c(
    "relative flex w-full flex-col justify-center",
    ke,
    e,
    De(i)
  ), m = r ? c(t) : c(
    te,
    t,
    Oe(),
    Be({ mode: s }),
    Ve({ focusMode: n }),
    He({
      noBorder: l,
      error: a
    }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": o
    }
  ), b = r ? void 0 : "sr-only", g = Ue({
    disabled: o,
    raw: r,
    error: a,
    mode: s
  }), h = Fe({
    error: a,
    raw: r,
    mode: s,
    disabled: o
  }), u = r ? void 0 : c(ve, "absolute");
  return {
    wrapper: d,
    textArea: m,
    accessibleLabel: b,
    visibleLabel: g,
    helperText: h,
    rightElement: u
  };
}, Se = ({
  scrollHeight: e,
  currentHeight: t,
  currentLabelOffset: r = 0,
  currentHelperTextOffset: n = 0
}) => {
  let o, l;
  if (e > 0 && e !== t) {
    const a = e - t, i = Math.abs(a / 24);
    o = r + -1 * Math.sign(a) * (12 * i), l = n + Math.sign(a) * (12 * i);
  }
  return {
    labelOffset: o,
    helperTextOffset: l,
    scrollHeight: e
  };
}, Pe = P.forwardRef(
  ({
    id: e,
    name: t,
    label: r,
    error: n = !1,
    raw: o = !1,
    className: l,
    textAreaClassName: a,
    mode: i = "system",
    focusMode: s = "system",
    value: d,
    defaultValue: m,
    disabled: b = !1,
    noBorder: g = !1,
    labelId: h,
    helperText: u = "",
    helperTextOnFocus: T = !1,
    rightElement: N,
    onChange: _,
    onFocus: E,
    onBlur: M,
    spacing: I,
    ...H
  }, R) => {
    const y = f(null), D = we([R, y]), [w, O] = Ae(), U = f(80), x = f(-25), k = f(null), S = f(30), B = f(null), F = Ee({ id: e, prefix: `${te}-` }), [ue, de] = A(0), [me, J] = A(
      !!(!T && u)
    ), pe = `${t} error, ${u}`, V = Le({
      className: l,
      textAreaClassName: a,
      error: n,
      raw: o,
      focusMode: s,
      disabled: b,
      noBorder: g,
      spacing: I,
      mode: i
    }), [$, fe] = Ne({
      value: d,
      initialControlledDelay: 20,
      defaultValue: m,
      onChange: (v) => {
        _ && _({
          target: {
            value: v
          }
        });
      }
    }), he = (v) => {
      fe(v.target.value);
    }, ye = (v) => {
      T && u && J(!0), E && E(v);
    }, be = (v) => {
      T && u && !$ && J(!1), M && M(v);
    };
    return L(() => {
      O && O.width && de(O.width + 18 + 10);
    }, [O]), L(() => {
      o || y && y.current && $ !== void 0 && (y.current.style.height = "inherit", y.current.style.height = y.current.scrollHeight + "px");
    }, [$, o]), L(() => {
      o || setTimeout(() => {
        var v;
        (v = k == null ? void 0 : k.current) == null || v.style.setProperty(
          "--av-text-area-wrapper-transition",
          $ ? "none" : "all 0.2s ease-out"
        );
      }, 0);
    }, [$, o]), L(() => {
      var v, Q;
      if (!o && y && y.current && $ !== void 0) {
        const { labelOffset: G, helperTextOffset: q, scrollHeight: ge } = Se({
          scrollHeight: y.current.scrollHeight,
          currentHeight: U.current,
          currentLabelOffset: x.current,
          currentHelperTextOffset: S.current
        });
        G && (x.current = G, (v = k == null ? void 0 : k.current) == null || v.style.setProperty(
          "--av-text-area-label",
          `${G}px`
        )), q && (S.current = q, (Q = B == null ? void 0 : B.current) == null || Q.style.setProperty(
          "--av-text-area-helper-text",
          `${q}px`
        )), U.current = ge || U.current;
      }
    }, [$, o]), /* @__PURE__ */ j("div", { className: V.wrapper, children: [
      /* @__PURE__ */ p(
        "label",
        {
          htmlFor: F,
          id: h,
          className: V.accessibleLabel,
          children: r
        }
      ),
      /* @__PURE__ */ p(
        "textarea",
        {
          ref: D,
          id: F,
          name: t,
          disabled: b,
          placeholder: o ? void 0 : " ",
          className: V.textArea,
          rows: 1,
          ...u && { "aria-describedby": `${F}-helper` },
          ...n && { "aria-invalid": "true" },
          ...N && !o && { style: { paddingRight: ue } },
          value: $,
          onChange: he,
          onFocus: ye,
          onBlur: be,
          ...H
        }
      ),
      !o && /* @__PURE__ */ p(
        "label",
        {
          ref: k,
          "aria-hidden": !0,
          htmlFor: F,
          className: V.visibleLabel,
          children: r
        }
      ),
      me && /* @__PURE__ */ p(
        "div",
        {
          ref: B,
          id: `${F}-helper`,
          className: V.helperText,
          children: u
        }
      ),
      N && /* @__PURE__ */ p(
        "div",
        {
          ref: w,
          className: V.rightElement,
          children: N
        }
      ),
      n && u && /* @__PURE__ */ p(Me, { politeness: "polite", clearAnnouncementDelay: 500, children: pe })
    ] });
  }
);
Pe.displayName = "TextArea";
const ae = "av-text-input", je = "av-text-input-wrapper", K = "av-text-input-helper-text";
function ze() {
  const e = f(!1);
  return C(() => (e.current = !0, () => {
    e.current = !1;
  }), []), re(() => e.current, []);
}
const Ge = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};
function qe(e) {
  const t = ze(), r = f(0), n = f(null), [o, l] = A(Ge), a = z(() => typeof ResizeObserver > "u" ? null : new ResizeObserver((i) => {
    const s = i[0];
    s && (cancelAnimationFrame(r.current), r.current = requestAnimationFrame(() => {
      n.current && t() && l(s.contentRect);
    }));
  }), [t]);
  return C(() => (n.current && (a == null || a.observe(n.current, e)), () => {
    a == null || a.disconnect(), r.current && cancelAnimationFrame(r.current);
  }), [a, e]), [n, o];
}
function Xe(e) {
  const t = Z();
  if (!e)
    return t;
  if (typeof e == "number" || typeof e == "string")
    return `${e}${t}`;
  if (typeof e == "object") {
    const { id: r, prefix: n = "" } = e;
    return typeof r == "number" || typeof r == "string" ? `${n}${r}` : `${n}${t}`;
  }
}
const le = "SET_ANNOUNCEMENT", ce = "CLEAR_ANNOUNCEMENT", Ke = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, Je = (e, t) => {
  switch (t == null ? void 0 : t.type) {
    case le:
      return {
        ...e,
        announcement: t.payload
      };
    case ce:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, Qe = ({
  onAnnouncementClear: e,
  dispatch: t
}) => {
  t({
    type: ce
  }), typeof e == "function" && e();
}, Y = ({
  children: e,
  clearAnnouncementDelay: t,
  clearAnnouncementTimeoutRef: r,
  onAnnouncementClear: n,
  dispatch: o
}) => {
  (r == null ? void 0 : r.current) !== null && clearTimeout(r.current), e !== null && o({
    type: le,
    payload: e
  }), t && (r.current = setTimeout(
    () => Qe({
      onAnnouncementClear: n,
      dispatch: o
    }),
    t
  ));
}, We = ({
  children: e,
  announcementTimeoutRef: t,
  announcementDelay: r,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: o,
  onAnnouncementClear: l,
  dispatch: a
}) => {
  clearTimeout(t.current), r ? t.current = setTimeout(Y, r, {
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: o,
    onAnnouncementClear: l,
    dispatch: a
  }) : Y({
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: o,
    onAnnouncementClear: l,
    dispatch: a
  });
};
function ie({
  children: e,
  className: t,
  politeness: r,
  role: n = null,
  announcementDelay: o,
  clearAnnouncementDelay: l,
  onAnnouncementClear: a,
  visible: i,
  ...s
}) {
  const d = f(), m = f(), [b, g] = ee(Je, {
    announcement: null
  });
  let h = r;
  typeof h > "u" && (h = n ? Ke[n] : "assertive"), C(() => {
    We({
      announcementTimeoutRef: d,
      announcementDelay: o,
      children: e,
      clearAnnouncementDelay: l,
      clearAnnouncementTimeoutRef: m,
      onAnnouncementClear: a,
      dispatch: g
    });
  }, [
    e,
    o,
    l,
    a
  ]);
  const u = c(t, {
    "sr-only": !i
  });
  return /* @__PURE__ */ p(
    "div",
    {
      "aria-live": h,
      ...n && { role: n },
      className: u,
      ...s,
      children: b.announcement
    }
  );
}
const Ye = (e) => {
  let t = "";
  if (typeof e == "number" || typeof e == "string")
    t = "m-" + e;
  else {
    const r = [];
    (e == null ? void 0 : e.t) !== void 0 && r.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && r.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && r.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && r.push(`ml-${e.l}`), t = r.join(" ");
  }
  return t;
};
/*!
  @versini/ui-private v1.4.10
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PRIVATE__ || (window.__VERSINI_UI_PRIVATE__ = {
    version: "1.4.10",
    buildTime: "09/18/2024 11:57 AM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Ze = ({
  mode: e
}) => c({
  "bg-surface-darker text-copy-lighter caret-copy-light": e === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": e === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": e === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": e === "alt-system"
}), er = ({
  focusMode: e
}) => c("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), rr = ({
  noBorder: e,
  error: t
}) => c("border-2", {
  "border-border-dark": !e && !t,
  "focus:border-border-dark": !e && t,
  "border-border-error-dark": !e && t,
  "border-transparent": e
}), tr = ({
  disabled: e,
  raw: t,
  error: r,
  mode: n
}) => {
  if (t)
    return "";
  if (e)
    return c("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!r)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": n === "dark",
      "text-copy-dark": n === "light",
      "text-copy-dark dark:text-copy-lighter": n === "system",
      "text-copy-lighter dark:text-copy-dark": n === "alt-system"
    });
  if (r)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": n === "dark",
      "text-copy-error-dark": n === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": n === "system",
      "text-copy-lighter dark:text-copy-error-dark": n === "alt-system"
    });
}, nr = ({
  error: e,
  raw: t,
  mode: r,
  disabled: n
}) => {
  if (t)
    return "";
  if (n)
    return c(
      K,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!e)
    return c(K, "absolute px-2 font-medium", {
      "text-copy-lighter": r === "dark",
      "text-copy-dark": r === "light",
      "text-copy-dark dark:text-copy-lighter": r === "system",
      "text-copy-lighter dark:text-copy-dark": r === "alt-system"
    });
  if (e)
    return c(K, "absolute px-2 font-medium", {
      "text-copy-error-light bg-surface-darker": r === "dark",
      "text-copy-error-dark": r === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": r === "system",
      "dark:text-copy-error-dark text-copy-error-light bg-surface-darker": r === "alt-system"
    });
}, or = ({
  className: e,
  inputClassName: t,
  raw: r,
  disabled: n,
  noBorder: o,
  error: l,
  spacing: a,
  mode: i,
  focusMode: s
}) => {
  const d = r ? e : c(
    "relative flex w-full flex-col justify-center",
    je,
    e,
    Ye(a)
  ), m = r ? c(t) : c(
    ae,
    t,
    "h-12 rounded-md px-4 text-base",
    Ze({ mode: i }),
    er({ focusMode: s }),
    rr({ noBorder: o, error: l }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": n
    }
  ), b = r ? void 0 : "sr-only", g = tr({
    disabled: n,
    raw: r,
    error: l,
    mode: i
  }), h = nr({
    error: l,
    raw: r,
    mode: i,
    disabled: n
  });
  return {
    wrapper: d,
    input: m,
    accessibleLabel: b,
    visibleLabel: g,
    helperText: h,
    rightElement: r ? void 0 : "absolute right-3"
  };
}, se = P.forwardRef(
  ({
    id: e,
    name: t,
    label: r,
    error: n = !1,
    raw: o = !1,
    className: l,
    inputClassName: a,
    mode: i = "system",
    focusMode: s = "system",
    disabled: d = !1,
    noBorder: m = !1,
    labelId: b,
    labelHidden: g = !1,
    type: h = "text",
    helperText: u = "",
    rightElement: T,
    spacing: N,
    ..._
  }, E) => {
    const [M, I] = qe(), [H, R] = A(0), y = Xe({ id: e, prefix: `${ae}-` }), D = `${t} error, ${u}`, w = or({
      className: l,
      inputClassName: a,
      error: n,
      raw: o,
      focusMode: s,
      disabled: d,
      noBorder: m,
      spacing: N,
      mode: i
    });
    return L(() => {
      I && I.width && R(I.width + 18 + 10);
    }, [I]), /* @__PURE__ */ j("div", { className: w.wrapper, children: [
      /* @__PURE__ */ p(
        "label",
        {
          htmlFor: y,
          id: b,
          className: w.accessibleLabel,
          children: r
        }
      ),
      /* @__PURE__ */ p(
        "input",
        {
          ref: E,
          id: y,
          name: t,
          type: h,
          disabled: d,
          placeholder: o ? void 0 : " ",
          className: w.input,
          ...u && { "aria-describedby": `${y}-helper` },
          ...n && { "aria-invalid": "true" },
          ...T && !o && { style: { paddingRight: H } },
          ..._
        }
      ),
      !o && !g && /* @__PURE__ */ p(
        "label",
        {
          "aria-hidden": !0,
          htmlFor: y,
          className: w.visibleLabel,
          children: r
        }
      ),
      u && /* @__PURE__ */ p(
        "div",
        {
          id: `${y}-helper`,
          className: w.helperText,
          children: u
        }
      ),
      T && /* @__PURE__ */ p(
        "div",
        {
          ref: M,
          className: w.rightElement,
          children: T
        }
      ),
      n && u && /* @__PURE__ */ p(ie, { politeness: "polite", clearAnnouncementDelay: 500, children: D })
    ] });
  }
);
se.displayName = "TextInput";
function ar(e) {
  return z(() => e.every((t) => t == null) ? () => {
  } : (t) => {
    e.forEach((r) => {
      typeof r == "function" ? r(t) : r != null && (r.current = t);
    });
  }, e);
}
const lr = 500, cr = 5e3, ir = 2e4, sr = P.forwardRef(
  ({
    name: e,
    disabled: t,
    label: r,
    labelHidden: n,
    onMaskChange: o,
    onChange: l,
    onBlur: a,
    onFocus: i,
    onTextInputMaskBlur: s,
    rightElement: d,
    spacing: m,
    ...b
  }, g) => {
    const [h, u] = A(!0), [T, N] = A({
      message: null,
      politeness: null
    }), _ = f(!0), E = f(), M = f(null), I = ar([g, M]), H = h ? "Show" : "Hide", R = () => {
      clearTimeout(E.current), _.current || (E.current = window.setTimeout(() => {
        _.current = !0, u(!0), N({
          announcementTimeout: cr,
          politeness: "polite",
          message: `${r} hiding characters`
        }), o && o(!0);
      }, ir));
    }, y = (x) => {
      x.preventDefault();
      const k = !_.current;
      _.current = k, R(), u(k), N({
        announcementTimeout: lr,
        politeness: "assertive",
        message: k ? "Characters hidden" : "Characters showing"
      }), o && o(k);
    }, D = (x) => {
      var k;
      const { relatedTarget: S } = x, B = (k = M.current) == null ? void 0 : k.parentElement;
      B != null && B.contains(S) || s && s();
    }, w = (x) => {
      R(), a && a(x), D(x);
    }, O = (x) => {
      R(), i && i(x);
    }, U = (x) => {
      R(), l && l(x);
    };
    return C(() => () => {
      clearTimeout(E.current);
    }, []), /* @__PURE__ */ j(xe, { children: [
      /* @__PURE__ */ p(
        se,
        {
          ref: I,
          name: e,
          label: r,
          labelHidden: n,
          type: h ? "password" : "text",
          disabled: t,
          spacing: m,
          onBlur: w,
          onFocus: O,
          onChange: U,
          rightElement: P.cloneElement(d, {
            ref: g,
            label: H,
            onClick: y,
            onBlur: D,
            disabled: t
          }),
          ...b
        }
      ),
      /* @__PURE__ */ p(
        ie,
        {
          role: "status",
          politeness: T.politeness,
          clearAnnouncementDelay: T.announcementTimeout,
          children: T.message
        }
      )
    ] });
  }
);
sr.displayName = "TextInputMask";
/*!
  @versini/ui-textinput v1.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_TEXTINPUT__ || (window.__VERSINI_UI_TEXTINPUT__ = {
    version: "1.0.0",
    buildTime: "09/18/2024 11:58 AM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
/*!
  @versini/ui-toggle v1.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_TOGGLE__ || (window.__VERSINI_UI_TOGGLE__ = {
    version: "1.0.0",
    buildTime: "09/18/2024 11:58 AM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const ur = "av-toggle", dr = (e) => {
  let t = "";
  if (typeof e == "number" || typeof e == "string")
    t = "m-" + e;
  else {
    const r = [];
    (e == null ? void 0 : e.t) !== void 0 && r.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && r.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && r.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && r.push(`ml-${e.l}`), t = r.join(" ");
  }
  return t;
}, mr = () => c("peer", "h-6", "w-11", "rounded-full"), pr = ({
  focusMode: e
}) => c(
  "peer-focus:outline",
  "peer-focus:outline-2",
  "peer-focus:outline-offset-2",
  {
    "peer-focus:outline-focus-dark": e === "dark",
    "peer-focus:outline-focus-light": e === "light",
    "peer-focus:outline-focus-light dark:peer-focus:outline-focus-dark": e === "alt-system",
    "peer-focus:outline-focus-dark dark:peer-focus:outline-focus-light": e === "system"
  }
), fr = () => c(
  "peer-checked:after:translate-x-full",
  // background color when checked
  "peer-checked:bg-violet-500",
  // knob circle and border color when checked
  "peer-checked:after:bg-white",
  "peer-checked:after:border-white"
), hr = () => c(
  "after:left-[2px]",
  "after:top-[2px]",
  "after:border",
  "after:border-surface-light dark:after:border-surface-medium",
  "after:bg-surface-light dark:after:bg-surface-medium",
  "after:absolute",
  "after:h-5",
  "after:w-5",
  "after:rounded-full",
  "after:transition-all",
  "after:content-['']"
), yr = ({
  mode: e,
  noBorder: t
}) => c({
  border: !t,
  "border-border-dark bg-surface-medium": e === "light",
  "border-border-light bg-surface-darker": e === "dark",
  "border-border-light bg-surface-darker dark:border-border-dark dark:bg-surface-medium": e === "alt-system",
  "border-border-dark bg-surface-medium dark:border-border-light dark:bg-surface-darker": e === "system"
}), br = ({
  mode: e,
  labelHidden: t
}) => t ? "sr-only" : c("ml-2 text-sm", {
  "text-copy-dark": e === "light",
  "text-copy-lighter": e === "dark",
  "text-copy-lighter dark:text-copy-dark": e === "alt-system",
  "text-copy-dark dark:text-copy-lighter": e === "system"
}), gr = ({ spacing: e }) => c(
  ur,
  "relative flex cursor-pointer items-center",
  dr(e)
), xr = ({
  mode: e,
  focusMode: t,
  labelHidden: r,
  spacing: n,
  noBorder: o
}) => ({
  toggle: c(
    mr(),
    yr({ mode: e, noBorder: o }),
    pr({ focusMode: t }),
    hr(),
    fr()
  ),
  label: br({ mode: e, labelHidden: r }),
  input: "peer sr-only",
  wrapper: gr({ spacing: n })
}), wr = ({
  checked: e = !1,
  onChange: t,
  label: r,
  labelHidden: n = !1,
  name: o,
  mode: l = "system",
  focusMode: a = "system",
  spacing: i,
  noBorder: s = !1
}) => {
  const d = xr({
    mode: l,
    focusMode: a,
    labelHidden: n,
    spacing: i,
    noBorder: s
  }), m = (b) => {
    t == null || t(b.target.checked);
  };
  return /* @__PURE__ */ j("label", { className: d.wrapper, children: [
    /* @__PURE__ */ p(
      "input",
      {
        name: o,
        checked: e,
        type: "checkbox",
        className: d.input,
        onChange: m
      }
    ),
    /* @__PURE__ */ p("div", { className: d.toggle }),
    /* @__PURE__ */ p("span", { className: d.label, children: r })
  ] });
};
export {
  Pe as TextArea,
  se as TextInput,
  sr as TextInputMask,
  wr as Toggle
};
